#! /usr/bin/perl
#
# lg.pl		Cisco Looking glass. To get this to work you need
#		to install Net::Telnet from the CPAN archives.
#
# Version:	@(#)lg.pl  1.01  21-Oct-1997  miquels@cistron.nl
#
#		Copyright (C) 1997 Cistron Internet Services B.V.
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; version 2 dated June, 1991.

use Net::Telnet 3.00;

require './lg.cfg';

$| = 1;
print <<EOF;
Pragma: no-cache
Content-type: text/html

EOF

#
#	Procedure to unquote a string.
#
sub http_unquote {
	$_ = $_[0];
	s/\+/ /g;
	s/\\(.)/$1/g;
	s/%(..)/sprintf ("%c", hex $1)/ge;
	s/\r//g;
	$_;
}
 
if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	sysread(STDIN, $ENV{'QUERY_STRING'}, $ENV{'CONTENT_LENGTH'});
}
$cnt = 0;
@pairs = split(/&/, $ENV{'QUERY_STRING'});
foreach (@pairs) {
	$_ = &http_unquote ($_);
	($name, $val) = split(/=/,$_, 2);
	$VAR{$name} = $val;
}
$query = $VAR{'query'};
$Company = $config::Company;
$Logo    = $config::Logo;
$Email   = $config::Email;

#
#	Empty query? Show the basic form.
#
if ($query eq '') {
	$options = "\n";
	for ($i = 0; $i <= $#config::Routers; $i++) {
		$sel = ($i == 0) ? ' Selected' : '';
		$val = $config::Routers[$i];
		$options .= "<Option Value = $val$sel> $val\n";
	}
	require './lg.html.inc';
	exit(0);
}

#
#	Find out which cisco we want to use.
#
if ($VAR{'router'} eq '') {
	print "No router defined\n";
	exit(1);
}
$nick = $config::cfg{$VAR{'router'}};
if (($Host = $nick->{Host}) eq '') {
	print "Unknown $VAR{'router'}\n";
	exit(1);
}
$Port = $nick->{Port};
$Prompt = $nick->{Prompt};
$Login = $nick->{Login};
$Pass = $nick->{Pass};
$Timeout = $nick->{Timeout};
$IXPoint = $nick->{IXPoint};

#
#	Try to make it secure.
#
$addr = $VAR{'addr'};
$addr =~ s/[^\-a-zA-Z0-9. \t_^\*\$]//g;
$addr =~ s/^\s+//;
$addr =~ s/\s+$//;
$addr = "4.0.0.0" if ($addr eq '');

print <<EOF;
<Html>
<Head>
<Title>$Company - $IXPoint Looking Glass Results</Title>
</Head>
<Body>

<img src="$Logo" alt="$Company">
<Center>
<H2>$IXPoint Looking Glass Results</H2>
</Center>
<P>
<Hr size=2 width=85%>
<P>

<Center>
<B>Query:</B> $query
EOF

#
#	See what command we want to send.
#

if ($query eq 'bgp') {
	$cmd = "show ip bgp $addr";
} elsif ($query eq 'summary') {
	$cmd = "show ip bgp summary";
	$addr = '';
} elsif ($query eq 'bgp dampened-paths') {
	$cmd = "show ip bgp dampened-paths";
	$addr = '';
} elsif ($query eq 'environmental') {
	$cmd = "show environment";
	$addr = '';
} elsif ($query eq 'bgp flap-statistics') {
	$cmd = "show ip bgp flap-statistics";
	$addr = '';
} elsif ($query eq 'ping') {
	$cmd = "ping $addr";
} elsif ($query eq 'trace') {
	$cmd = "trace $addr";
} else {
	$cmd = "show clock";
	$addr = '';
}
print "<Br><B>Addr:</B> $addr\n" if ($addr ne '');
print "</Center><P><Pre>\n";

$ses = new Net::Telnet  (Host => $Host,
                        Port => $Port,
                        Prompt => "/$Prompt/i",
			Timeout => $Timeout);

if (!$ses) {
	print "lg.pl: connect to router $Host failed\n";
	exit(1);
}

#
#	Login and turn off `more' style paging.
#
if ($Login ne '' and $Pass ne '') {
	$ses->login($Login, $Pass);
} elsif ($Login eq '' and $Pass ne '') {
	$ses->waitfor('/password[: ]*$/i');
	$ses->cmd($Pass);
} else {
	$ses->waitfor("/$Prompt/i");
}
$ses->cmd("term len 0");

#
#	Send command.
#
$ses->print($cmd);

#
#	Print the output up to the next prompt.
#
$first = 1;
$ses->input_record_separator("\xff");

while (($junk, $_) = $ses->waitfor("/(^.*\n|$Prompt)/i")) {
	if ($first) {
		$first = 0;
		next;
	}
	last if (/$Prompt/);
	print;
}
$ses->input_record_separator("\n");
$ses->cmd("exit");
$ses->close;

print <<EOF;
</Pre>
<P>
<Hr size=2 width=85%>
<P>
</Body>
<Tail>
<Center>
<I>
  Please e-mail questions or comments to
 <A href=mailto:$Email>$Email</A>.
</I>
</Center>
</Tail>
</Html>
EOF

0;
